package com.example.pietroemporio.wikitude;

import android.Manifest;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/*
Classe principale chiede al sistema le autorizzazioni per funzionare, una
volta che le ha ottenute lancia l'applicativo wikitude
*/
public class MainActivity extends AppCompatActivity {
    public  static final int PERMISSIONS_MULTIPLE_REQUEST = 456;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        try {
            checkPermission();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Override
    protected void onPostCreate (Bundle savedInstanceState){
        super.onPostCreate(savedInstanceState);
    }

    @Override
    protected void onResume (){
        super.onResume();
    }

    @Override
    protected void onDestroy (){
        super.onDestroy();
    }

    @Override
    protected void onPause (){
        super.onPause();
    }

    private void checkPermission() throws IOException {

        if (Build.VERSION.SDK_INT < 23) {

        } else {
            checkAndRequestPermissions();
        }
    }


    private void checkAndRequestPermissions() throws IOException {
        /*
        * LISTA DI PERMESSI
        *
        * A partire da android 6.0 i permessi sono richiesti a runtime
        * Occorre creare una lista di permessi e chiedere all'utente le autorizzazioni
        * NOTE: solo permessi DANGEROUS
        */
        List<String> listPermissionsNeeded = new ArrayList<>();
        if (ContextCompat.checkSelfPermission(this,
                Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            listPermissionsNeeded.add(Manifest.permission.ACCESS_FINE_LOCATION);
        }
        if (ContextCompat.checkSelfPermission(this,
                Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED) {
            listPermissionsNeeded.add(Manifest.permission.CAMERA);
        }
        if (ContextCompat.checkSelfPermission(this,
                Manifest.permission.WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED) {
            listPermissionsNeeded.add(Manifest.permission.WRITE_EXTERNAL_STORAGE);
        }
        if (ContextCompat.checkSelfPermission(this,
                Manifest.permission.READ_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED) {
            listPermissionsNeeded.add(Manifest.permission.READ_EXTERNAL_STORAGE);
        }
        if (!listPermissionsNeeded.isEmpty()) {
            ActivityCompat.requestPermissions(this,listPermissionsNeeded.toArray(new String[listPermissionsNeeded.size()]), PERMISSIONS_MULTIPLE_REQUEST);
        }else{
            Intent intent = new Intent(this, ArActivity.class);
            startActivity(intent);
        }

    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
         /*
        *
        * EVENTO: risultato delle risposte dell'utente alla richiesta dei permessi
        *
        */
        switch (requestCode) {
            case PERMISSIONS_MULTIPLE_REQUEST:
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    // APPLICATIVO Wikitude
                    Intent intent = new Intent(this, ArActivity.class);
                    startActivity(intent);
                } else {
                    //You did not accept the request can not use the functionality.
                    /*KILL APP*/
                }
                break;
        }
    }
}
